local function boolToString(value)
	if value then
		return "true"
	end
	return "false"
end

local function stringToBool(text)
	if text == "true" then
		return true
	end
	return false

end














function convertTrackerToString(index,typeOfTracker)
	local string = ""
	--typeOfTracker
	--0 debuff
	--1 buff
	--2 cooldown
	if typeOfTracker == 1 then
		local tracker = HTTsavedVars[HTT_variables.currentlySelectedProfile].debuffTable[index]
		string = string..typeOfTracker.."#"..tracker.name.."#"..","..tracker.color[1]..","..tracker.color[2]..","..tracker.color[3]..","..(tracker.color[4] or 1)..",#"
		for k,v in pairs(tracker.IDs) do
			string = string..","..v
		end
		string = string..",#"..tracker.icon.."#"
		for k,v in pairs(tracker.skill) do
			string = string..","..v
		end
		string = string..",#"
		for k,v in pairs(tracker.itemSet[1]) do
			string = string..","..v
		end
		string = string..",#"..(tracker.itemSet[2] or 0).."#"..tracker.text.."#"..tracker.textWhenMissing.."#"..boolToString(tracker.onlyCastByPlayer).."#"
	elseif typeOfTracker == 2 then
		local tracker = HTTsavedVars[HTT_variables.currentlySelectedProfile].buffTable[index]
		string = string..typeOfTracker.."#"..tracker.name.."#"..","..tracker.color[1]..","..tracker.color[2]..","..tracker.color[3]..","..(tracker.color[4] or 1)..",#"
		for k,v in pairs(tracker.IDs) do
			string = string..","..v
		end
		string = string..",#"..tracker.icon.."#"
		for k,v in pairs(tracker.skill) do
			string = string..","..v
		end
		string = string..",#"
		for k,v in pairs(tracker.itemSet[1]) do
			string = string..","..v
		end
		string = string..",#"..(tracker.itemSet[2] or 0).."#"..tracker.text.."#"..tracker.textWhenMissing.."#"
	elseif typeOfTracker == 3 then
		local tracker = HTTsavedVars[HTT_variables.currentlySelectedProfile].cooldownTable[index]
		string = string..typeOfTracker.."#"..tracker.name.."#"..","..tracker.color[1]..","..tracker.color[2]..","..tracker.color[3]..","..(tracker.color[4] or 1)..",#"
		for k,v in pairs(tracker.IDs) do
			string = string..","..v
		end
		string = string..",#"..tracker.icon.."#"
		for k,v in pairs(tracker.skill) do
			string = string..","..v
		end
		string = string..",#"
		for k,v in pairs(tracker.itemSet[1]) do
			string = string..","..v
		end
		string = string..",#"..(tracker.itemSet[2] or 0).."#"..tracker.text.."#"..tracker.textWhenMissing.."#"..tracker.duration.."#"
	elseif typeOfTracker == 4 then
		local tracker = HTTsavedVars[HTT_variables.currentlySelectedProfile].synergiesTable[index]
		string = string..typeOfTracker.."#"..tracker.name.."#"..","..tracker.color[1]..","..tracker.color[2]..","..tracker.color[3]..","..(tracker.color[4] or 1)..",#"
		for k,v in pairs(tracker.IDs) do
			string = string..","..v
		end
		string = string..",#"..tracker.icon.."#"
		string = string..",#"..tracker.text.."#"..tracker.textWhenMissing.."#"
	end
	return string
end

function loadTrackerFromString(startingString)
	local string = dec(startingString)
	local typeOfTracker = tonumber(string.sub(string, 1, 1))

	local t = {}                   
    local i = 0
    while true do
		i = string.find(string, "#", i+1)    
		if i == nil then break end
		table.insert(t, i)
    end

	if typeOfTracker == 1 then
		--name
		local name = string.sub(string, t[1]+1, t[2]-2)

		--color
		local t1 = {}                   
		local i1 = 0
		local colorString = string.sub(string, t[2]+1, t[3]-1)
		while true do
			i1 = string.find(colorString, ",", i1+1)    
			if i1 == nil then break end
			table.insert(t1, i1)
		end
		local color1 = string.sub(colorString, t1[1]+1, t1[2]-1)
		local color2 = string.sub(colorString, t1[2]+1, t1[3]-1)
		local color3 = string.sub(colorString, t1[3]+1, t1[4]-1)
		local color4 = string.sub(colorString, t1[4]+1, t1[5]-1)
		local color = {color1,color2,color3,color4}

		--IDs
		local IDs = {}
		local t2 = {}                   
		local i2 = 0
		local idString = string.sub(string, t[3]+1, t[4]-1)
		while true do
			i2 = string.find(idString, ",", i2+1)    
			if i2 == nil then break end
			table.insert(t2, i2)
		end
		for x=1, #t2-1 do
			table.insert(IDs,tonumber(string.sub(idString, t2[x]+1, t2[x+1]-1)))
		end

		--icon
		local icon = string.sub(string, t[4]+1, t[5]-1)
		
		--skills
		local skills = {}
		local t3 = {}                   
		local i3 = 0
		local skillString = string.sub(string, t[5]+1, t[6]-1)
		while true do
			i3 = string.find(skillString, ",", i3+1)    
			if i3 == nil then break end
			table.insert(t3, i3)
		end
		for x=1, #t3-1 do
			table.insert(IDs,tonumber(string.sub(idString, t3[x]+1, t3[x+1]-1)))
		end

		--itemSets
		local itemSets = {}
		local t4 = {}                   
		local i4 = 0
		local itemSetsString = string.sub(string, t[6]+1, t[7]-1)
		while true do
			i4 = string.find(itemSetsString, ",", i4+1)    
			if i4 == nil then break end
			table.insert(t4, i4)
		end
		for x=1, #t4-1 do
			table.insert(IDs,tonumber(string.sub(idString, t4[x]+1, t4[x+1]-1)))
		end

		--itemSetsNumber
		local itemSetsNumber = tonumber(string.sub(string, t[7]+1, t[8]-1))

		--text
		local text = string.sub(string, t[8]+1, t[9]-1)

		--textWhenMissing
		local textWhenMissing = string.sub(string, t[9]+1, t[10]-1)

		--onlyCastByPlayer
		local onlyCastByPlayer = stringToBool(string.sub(string, t[10]+1, t[11]-1))


		local tableSlot = HTT_functions.findFreeSlotInTable(HTTsavedVars[HTT_variables.currentlySelectedProfile].debuffTable)
		HTT_functions.addDebuff(name,IDs,tableSlot,text,textWhenMissing,color,nil,nil,onlyCastByPlayer,skill,itemSets,itemSetsNumber,icon)

	elseif typeOfTracker == 2 then
		--name
		local name = string.sub(string, t[1]+1, t[2]-2)

		--color
		local t1 = {}                   
		local i1 = 0
		local colorString = string.sub(string, t[2]+1, t[3]-1)
		while true do
			i1 = string.find(colorString, ",", i1+1)    
			if i1 == nil then break end
			table.insert(t1, i1)
		end
		local color1 = string.sub(colorString, t1[1]+1, t1[2]-1)
		local color2 = string.sub(colorString, t1[2]+1, t1[3]-1)
		local color3 = string.sub(colorString, t1[3]+1, t1[4]-1)
		local color4 = string.sub(colorString, t1[4]+1, t1[5]-1)
		local color = {color1,color2,color3,color4}

		--IDs
		local IDs = {}
		local t2 = {}                   
		local i2 = 0
		local idString = string.sub(string, t[3]+1, t[4]-1)
		while true do
			i2 = string.find(idString, ",", i2+1)    
			if i2 == nil then break end
			table.insert(t2, i2)
		end
		for x=1, #t2-1 do
			table.insert(IDs,tonumber(string.sub(idString, t2[x]+1, t2[x+1]-1)))
		end

		--icon
		local icon = string.sub(string, t[4]+1, t[5]-1)
		
		--skills
		local skills = {}
		local t3 = {}                   
		local i3 = 0
		local skillString = string.sub(string, t[5]+1, t[6]-1)
		while true do
			i3 = string.find(skillString, ",", i3+1)    
			if i3 == nil then break end
			table.insert(t3, i3)
		end
		for x=1, #t3-1 do
			table.insert(IDs,tonumber(string.sub(idString, t3[x]+1, t3[x+1]-1)))
		end

		--itemSets
		local itemSets = {}
		local t4 = {}                   
		local i4 = 0
		local itemSetsString = string.sub(string, t[6]+1, t[7]-1)
		while true do
			i4 = string.find(itemSetsString, ",", i4+1)    
			if i4 == nil then break end
			table.insert(t4, i4)
		end
		for x=1, #t4-1 do
			table.insert(IDs,tonumber(string.sub(idString, t4[x]+1, t4[x+1]-1)))
		end

		--itemSetsNumber
		local itemSetsNumber = tonumber(string.sub(string, t[7]+1, t[8]-1))

		--text
		local text = string.sub(string, t[8]+1, t[9]-1)

		--textWhenMissing
		local textWhenMissing = string.sub(string, t[9]+1, t[10]-1)


		local tableSlot = HTT_functions.findFreeSlotInTable(HTTsavedVars[HTT_variables.currentlySelectedProfile].buffTable)
		HTT_functions.addBuff(name,IDs,tableSlot,text,textWhenMissing,color,nil,nil,skill,itemSets,itemSetsNumber,icon)

	elseif typeOfTracker == 3 then
		--name
		local name = string.sub(string, t[1]+1, t[2]-2)

		--color
		local t1 = {}                   
		local i1 = 0
		local colorString = string.sub(string, t[2]+1, t[3]-1)
		while true do
			i1 = string.find(colorString, ",", i1+1)    
			if i1 == nil then break end
			table.insert(t1, i1)
		end
		local color1 = string.sub(colorString, t1[1]+1, t1[2]-1)
		local color2 = string.sub(colorString, t1[2]+1, t1[3]-1)
		local color3 = string.sub(colorString, t1[3]+1, t1[4]-1)
		local color4 = string.sub(colorString, t1[4]+1, t1[5]-1)
		local color = {color1,color2,color3,color4}

		--IDs
		local IDs = {}
		local t2 = {}                   
		local i2 = 0
		local idString = string.sub(string, t[3]+1, t[4]-1)
		while true do
			i2 = string.find(idString, ",", i2+1)    
			if i2 == nil then break end
			table.insert(t2, i2)
		end
		for x=1, #t2-1 do
			table.insert(IDs,tonumber(string.sub(idString, t2[x]+1, t2[x+1]-1)))
		end

		--icon
		local icon = string.sub(string, t[4]+1, t[5]-1)
		
		--skills
		local skills = {}
		local t3 = {}                   
		local i3 = 0
		local skillString = string.sub(string, t[5]+1, t[6]-1)
		while true do
			i3 = string.find(skillString, ",", i3+1)    
			if i3 == nil then break end
			table.insert(t3, i3)
		end
		for x=1, #t3-1 do
			table.insert(IDs,tonumber(string.sub(idString, t3[x]+1, t3[x+1]-1)))
		end

		--itemSets
		local itemSets = {}
		local t4 = {}                   
		local i4 = 0
		local itemSetsString = string.sub(string, t[6]+1, t[7]-1)
		while true do
			i4 = string.find(itemSetsString, ",", i4+1)    
			if i4 == nil then break end
			table.insert(t4, i4)
		end
		for x=1, #t4-1 do
			table.insert(IDs,tonumber(string.sub(idString, t4[x]+1, t4[x+1]-1)))
		end

		--itemSetsNumber
		local itemSetsNumber = tonumber(string.sub(string, t[7]+1, t[8]-1))

		--text
		local text = string.sub(string, t[8]+1, t[9]-1)

		--textWhenMissing
		local textWhenMissing = string.sub(string, t[9]+1, t[10]-1)

		--onlyCastByPlayer
		local duration = ntonumber(string.sub(string, t[10]+1, t[11]-1))


		local tableSlot = HTT_functions.findFreeSlotInTable(HTTsavedVars[HTT_variables.currentlySelectedProfile].cooldownTable)
		HTT_functions.addCooldown(name,IDs,tableSlot,text,textWhenMissing,color,nil,nil,duration, skill,itemSets,itemSetsNumber,icon)
	end
end
			

function convertProfileToString()
	local string = "#"
	for k,v in pairs(HTTsavedVars[HTT_variables.currentlySelectedProfile]) do
		if k=="alertNotifications" then
			d("schlech")
		elseif k == "debuffTable" then
			string = string.."debuffs@"
			for k1,v1 in pairs(v) do
				string = string..k1.."="..convertTrackerToString(k1,1).."@"
			end
		elseif k == "buffTable" then
			string = string.."buffs@"
			for k1,v1 in pairs(v) do
				string = string..k1.."="..convertTrackerToString(k1,2).."@"
			end
		elseif k == "cooldownTable" then
			string = string.."cooldowns@"
			for k1,v1 in pairs(v) do
				string = string..k1.."="..convertTrackerToString(k1,3).."@"
			end
		elseif k == "synergiesTable" then
			string = string.."synergies@"
			for k1,v1 in pairs(v) do
				string = string..k1.."="..convertTrackerToString(k1,4).."@"
			end
		elseif type(v) == "table" then
			d(k)
			for k1,v1 in pairs(v) do
				string = string..","..k1.."="..v1
			end
			string = string..",#"
		else
			if type(v) == "boolean" then
				string = string..k.."="..boolToString(v).."#"
			else
				string = string..k.."="..v.."#"
			end
		end
	end
	return string





end

function importProfileFromString(profileName)
	local profile = {}
	local previous = nil                  
    local current = nil
    while true do
		current = string.find(string, "#", i+1)    
		if i == nil then break end
		if previous then

		end
		previous = current
    end


end

local types = {
	["number"] = "N",
	["boolean"] = "B",
	["string"] = "S",
}

function convertToString(exportTable)
	local exportString = "<"
	if type(exportTable) == "table" then
		for k,v in pairs(exportTable) do
			exportString = exportString..convertToString(k)..convertToString(v)
		end
	else
		if type(exportTable) == "boolean" then
			exportString = exportString.."B"..boolToString(exportTable)
		else
			exportString = exportString..types[type(exportTable)]..exportTable
		end
	end
	return exportString..">"
end


testString = "<SdebuffBossUIWidth><N210><SyOffsetHealth><N200><SyOffsetCooldowns><N200><SclassSpecialIsOn><Btrue><SisStraightResourceOn><Bfalse><SdebuffBossUIHeight><N20><SdebuffTable><<Snone><<SturnedOnBoss><Bfalse><Sname><Snone><SturnedOn><Bfalse><Scolor2><<N1><N0><N2><N0><N3><N0><N4><N0>><SonlyCastByPlayer><Bfalse><StextWhenMissing><Snone><Scolor><<N1><N0><N2><N0><N3><N0><N4><N0>><Sduration><><Stext><Snone><Sskill><><SitemSet><<N1><>><SIDs><><SexpiresAt><><Scolor3><<N1><N0><N2><N0><N3><N0><N4><N0>><Sicon><Snone>>><SbuffBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SorderOfBuffs><><SsynergyNameToID><><SxOffset><N200><SoffBalanceImmunityText><SOff-Balance Immunity><SbuffFont><SZoFontGameSmall><ScooldownFont><SZoFontGameSmall><SxOffsetBoss2><N200><SbuffTable><<Snone><<Sskill><><Sname><Snone><SturnedOn><Bfalse><Scolor><<N1><N0><N2><N0><N3><N0><N4><N0>><Sduration><N0><Stext><Snone><SitemSet><<N1><>><SIDs><><StextWhenMissing><Snone><SexpiresAt><N0><Sicon><Snone>>><SisBossDebuffUIOn><Bfalse><SxOffsetHealthStraight><N0><SbuffUIWidth><N210><SisAlertUIOn><Btrue><SalertUIScale><N1><SisBlockUIOn><Btrue><SxOffsetOlms><N0><SyOffsetSelfBuffs><N200><SxOffsetBoss6><N200><SisBaseGameUIOn><Btrue><SxOffsetSynergies><N200><SyOffsetStamina><N200><SsynergiesFont><SZoFontGameSmall><SspecialUIWidth><N210><SxOffsetAlert><N200><Sheight><N40><ScooldownUIHeight><N20><SreflectIndicatorColor><<N4><N1><N1><N1><N2><N1><N3><N1>><SisBlockCostOn><Btrue><SxOffsetBoss4><N200><SxOffsetStaminaStraight><N0><SspecialFont><SZoFontGameSmall><SorderOfCooldowns><><SyOffsetMagicka><N200><SxOffsetFelms><N0><SisCooldownUIOn><Btrue><SdebuffUIHeight><N20><ScooldownUIScale><N1><SxOffsetBlock><N200><ScurrentlySelectedBarTexture><SHyperTankingTools/icons/gradientProgressBar.dds><SxOffsetBosses><N200><SxOffsetCooldowns><N200><SisStoneFistCustomIconOn><Btrue><SxOffsetHealth><N200><SalertUIWidth><N210><SyOffsetBoss3><N200><SorderOfSynergies><<N1><N1><N2><N2><N3><N3><N4><N4><N5><N5><N6><N6><N7><N7><N8><N8><N9><N9><N10><N10><N11><N11><N12><N12><N13><N13><N14><N14><N15><N15><N16><N16><N17><N17>><SyOffsetSynergies><N200><SyOffsetBosses><N200><SshieldTextureHeight><N170><ScooldownTable><<Snone><<Sskill><><Sname><Snone><SturnedOn><Bfalse><Scolor><<N1><N0><N2><N0><N3><N0><N4><N0>><Sduration><N0><Stext><Snone><SitemSet><<N1><>><SIDs><><StextWhenMissing><Snone><SexpiresAt><N0><Sicon><Snone>>><SxOffsetBoss1><N200><SyOffset><N200><SsynergiesUIScale><N1><SisSynergiesUIOn><Btrue><SyOffsetBoss2><N200><SsynergiesUIHeight><N20><SisAltResourceUIOn><Bfalse><SbuffUIScale><N1><SsynergiesBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SxOffsetSelfBuffs><N200><SisReflectIndicatorOn><Btrue><SyOffsetBlock><N200><SbossFont><SZoFontGameSmall><SclassSpecialColor><<N4><N1><N1><N1><N2><N0.84><N3><N0.19>><SyOffsetBoss1><N200><Swidth><N200><SspecialBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SsynergiesUIWidth><N210><SisSpecialUIOn><Btrue><SbossBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SxOffsetMagickaStraight><N0><SyOffsetMagickaStraight><N0><SdebuffUIScale><N1><SyOffsetBoss6><N200><SspecialUIHeight><N70><SdebuffNameToID><><ScooldownNameToID><><SisBuffUIOn><Btrue><SdebuffFont><SZoFontGameSmall><SdebuffBossUIScale><N1><SalertNotifications><<N133440><Btrue><N103553><Bfalse><N103555><Bfalse><N95428><Btrue><N137285><Btrue><N141958><Btrue><N106375><Bfalse><N137544><Btrue><N115723><Bfalse><N17228><Bfalse><N98895><Bfalse><N98896><Bfalse><N135953><Btrue><N142612><Btrue><N17046><Bfalse><N104535><Bfalse><N123099><Bfalse><N104413><Bfalse><N150366><Btrue><N151647><Btrue><N146142><Btrue><N99974><Bfalse><N115589><Bfalse><N140035><Btrue><N121833><Bfalse><N146747><Btrue><N76538><Bfalse><N150380><Btrue><N95545><Btrue><N17728><Bfalse><N76335><Bfalse><N105968><Bfalse><N119283><Bfalse><N87346><Bfalse><N141427><Btrue><N105780><Bfalse><N146677><Btrue><N137833><Btrue><N105975><Bfalse><N104755><Bfalse><N146681><Btrue><N125690><Btrue><N121723><Bfalse><N146179><Btrue><N142717><Btrue><N122124><Bfalse><N140031><Btrue>><SxOffsetBoss5><N200><SisDebuffUIOn><Btrue><SbuffUIHeight><N20><SshieldTextureWidth><N170><SreticleBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SxOffsetMagicka><N200><SyOffsetHealthStraight><N0><SisAutoCooldownTurnedOn><Btrue><SdebuffUIWidth><N210><SxOffsetStamina><N200><SalertUIHeight><N20><ScooldownBackgroundColor><<N4><N1><N1><N0><N2><N0><N3><N0>><SyOffsetOwnStacks><N200><SxOffsetOwnStacks><N200><SyOffsetOlms><N0><SyOffsetStaminaStraight><N0><SyOffsetFelms><N0><SyOffsetBoss4><N200><SorderOfDebuffs><><SbuffNameToID><><ScustomShield><SHyperTankingTools/icons/customShield3.dds><SsynergiesTable><<N1><<StextWhenMissing><SSanguine Burst ready><Sname><SSanguine Burst><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_u23_bloodball_chokeonit.dds><SIDs><<N1><N142305>><SexpiresAt><N0><Stext><SSanguine Burst on cooldown><Scolor><<N4><N1><N1><N0.8117647171><N2><N0><N3><N0.200000003>>><N2><<StextWhenMissing><SResource Restore ready><Sname><SResource Restore><SturnedOn><Btrue><Sicon><S/esoui/art/icons/ability_undaunted_004.dds><SIDs><<N4><N95928><N1><N63507><N2><N39301><N3><N94973>><SexpiresAt><N0><Stext><SResource Restore on cooldown><Scolor><<N4><N1><N1><N0.2235294133><N2><N0.8117647171><N3><N0>>><N3><<StextWhenMissing><SHidden Refresh ready><Sname><SHidden Refresh><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_nightblade_015.dds><SIDs><<N1><N37729>><SexpiresAt><N0><Stext><SHidden Refresh on cooldown><Scolor><<N4><N1><N1><N0.4666666687><N2><N0><N3><N0.1137254909>>><N4><<StextWhenMissing><SSpiders ready><Sname><SSpiders><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_undaunted_003.dds><SIDs><<N1><N41994><N2><N39429><N3><N42016>><SexpiresAt><N0><Stext><SSpiders on cooldown><Scolor><<N4><N1><N1><N0.9568627477><N2><N1><N3><N0.360784322>>><N5><<StextWhenMissing><SBone Shield ready><Sname><SBone Shield><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_undaunted_005.dds><SIDs><<N2><N42198><N1><N39379>><SexpiresAt><N0><Stext><SBone Shield on cooldown><Scolor><<N4><N1><N1><N0.8235294223><N2><N1><N3><N0.6156862974>>><N6><<StextWhenMissing><SBlood Altar ready><Sname><SBlood Altar><SturnedOn><Btrue><Sicon><S/esoui/art/icons/ability_undaunted_001.dds><SIDs><<N2><N39501><N1><N41964>><SexpiresAt><N0><Stext><SBlood Altar on cooldown><Scolor><<N4><N1><N1><N1><N2><N0><N3><N0.160784319>>><N7><<StextWhenMissing><SRadiate ready><Sname><SRadiate><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_undaunted_002.dds><SIDs><<N1><N41838>><SexpiresAt><N0><Stext><SRadiate on cooldown><Scolor><<N4><N1><N1><N1><N2><N0.501960814><N3><N0>>><N8><<StextWhenMissing><SSoul Leech ready><Sname><SSoul Leech><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_nightblade_018.dds><SIDs><<N1><N25170>><SexpiresAt><N0><Stext><SSoul Leech on cooldown><Scolor><<N4><N1><N1><N1><N2><N0.5176470876><N3><N0.5098039508>>><N9><<StextWhenMissing><SConduit ready><Sname><SConduit><SturnedOn><Btrue><Sicon><S/esoui/art/icons/ability_sorcerer_lightning_splash.dds><SIDs><<N1><N43769>><SexpiresAt><N0><Stext><SConduit on cooldown><Scolor><<N4><N1><N1><N0.1294117719><N2><N0.4823529422><N3><N0.8117647171>>><N10><<StextWhenMissing><SAttronach ready><Sname><SAttronach><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_sorcerer_storm_atronach.dds><SIDs><<N1><N121059>><SexpiresAt><N0><Stext><SAttronach on cooldown><Scolor><<N4><N1><N1><N0.1450980455><N2><N0><N3><N1>>><N11><<StextWhenMissing><SSupernova ready><Sname><SSupernova><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_templar_nova.dds><SIDs><<N2><N48938><N1><N48939>><SexpiresAt><N0><Stext><SSupernova on cooldown><Scolor><<N4><N1><N1><N1><N2><N0.9686274529><N3><N0.4078431427>>><N12><<StextWhenMissing><SIgnite ready><Sname><SIgnite><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_dragonknight_010.dds><SIDs><<N1><N32974>><SexpiresAt><N0><Stext><SIgnite on cooldown><Scolor><<N4><N1><N1><N1><N2><N0.2666666806><N3><N0>>><N13><<StextWhenMissing><SShackle ready><Sname><SShackle><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_dragonknight_006.dds><SIDs><<N1><N32910>><SexpiresAt><N0><Stext><SShackle on cooldown><Scolor><<N4><N1><N1><N1><N2><N0.4470588267><N3><N0>>><N14><<StextWhenMissing><SHarvest ready><Sname><SHarvest><SturnedOn><Btrue><Sicon><S/esoui/art/icons/ability_warden_007.dds><SIDs><<N1><N85572>><SexpiresAt><N0><Stext><SHarvest on cooldown><Scolor><<N4><N1><N1><N0.3882353008><N2><N0.8313725591><N3><N0.4196078479>>><N15><<StextWhenMissing><SGate ready><Sname><SGate><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_warden_005_b.dds><SIDs><<N1><N88892>><SexpiresAt><N0><Stext><SGate on cooldown><Scolor><<N4><N1><N1><N0.6156862974><N2><N0.9647058845><N3><N1>>><N16><<StextWhenMissing><SGrave Robber ready><Sname><SGrave Robber><SturnedOn><Btrue><Sicon><S/esoui/art/icons/ability_necromancer_004.dds><SIDs><<N1><N115567>><SexpiresAt><N0><Stext><SGrave Robber on cooldown><Scolor><<N4><N1><N1><N0.4078431427><N2><N0.2392156869><N3><N0.8117647171>>><N17><<StextWhenMissing><SPure Agony ready><Sname><SPure Agony><SturnedOn><Bfalse><Sicon><S/esoui/art/icons/ability_necromancer_010_b.dds><SIDs><<N1><N118610>><SexpiresAt><N0><Stext><SPure Agony on cooldown><Scolor><<N4><N1><N1><N0.1529411823><N2><N0><N3><N1>>><Snone><<StextWhenMissing><Snone><Sname><Snone><SturnedOn><Bfalse><Stext><Snone><SIDs><><SexpiresAt><N0><Sicon><Snone><Scolor><<N1><N0><N2><N0><N3><N0><N4><N0>>>><StrackOnlyDD><Bfalse><SxOffsetLlothis><N0><SyOffsetBoss5><N200><ScooldownUIWidth><N210><SxOffsetBoss3><N200><SyOffsetLlothis><N0><SspecialUIScale><N1>"

function importFromString(importString)
	local result = {}
    local lefts = {}                   
    local n = 0
	local key = nil
	for i=0, #importString do
		local c = string.sub(importString,i,i)
		if c == "<" then
			n=n+1
			table.insert(lefts,i)
		elseif c == ">" then
			if n==1 then
				if key then
					if #lefts > 1 then
						result[key] = importFromString(string.sub(importString,lefts[1]+1,i-1))
						key = nil
					else
						local type = string.sub(importString,lefts[1]+1,lefts[1]+1)
						if type == "N" then
							result[key] = tonumber(string.sub(importString,lefts[1]+2,i-1))
						elseif type == "B" then
							result[key] = stringToBool(string.sub(importString,lefts[1]+2,i-1))
						elseif type == "S" then
							result[key] = string.sub(importString,lefts[1]+2,i-1)
						else
							result[key] = {}
						end
					end
					key = nil
				else
					local type = string.sub(importString,lefts[1]+1,lefts[1]+1)
					if type == "N" then
						key = tonumber(string.sub(importString,lefts[1]+2,i-1))
					elseif type == "B" then
						key = stringToBool(string.sub(importString,lefts[1]+2,i-1))
					else
						key = string.sub(importString,lefts[1]+2,i-1)
					end
				end
				lefts = {}
				n = 0
			else
				n=n-1
			end
		end
	end
	return result
end

